# Cutscenes

 A minecraft plugin that makes cutscenes...
 
## How to use

### Create a cutscene

To create a cutscene, you need to create a folder in the `plugins/ScaredRealms/cutscenes` folder. The folder can be named anything, i recommend that the folder is the name of the cutscene.Inside this folder, make a file named `cutscene.yml`.
Here's an example : 
```yaml
name: "Cutscene name"
id: "TUTORIAL"
start: "world,10,10,10,5,5"
end: "world,20,20,20,150,150"
markers:
  - "1"
  - "2"
  - "3"
```

A Location is composed of the world name, the x, y and z coordinates and the yaw and pitch.

The `name` is the name of the cutscene, the `id` is the id of the cutscene (must be without space and unique), the `start` is the start location of the cutscene, the `end` is the end location of the cutscene and the `markers` is a list of markers of the cutscene.
Next create folders for each marker. In this example we have 3 markers, so we need to create 3 folders named `1`, `2` and `3`. In each folder, create a file named `marker.yml`. Here's an example : 
```yaml
id: "1"
cutscene_id: "tutorial"
start: "world,10,10,10,5,5"
timeBetweenFrames: "50"
overAllTime: "25000"
```

The `id` is the id of the marker (must be without space and unique), the `cutscene_id` is the id of the cutscene, the `start` is the start location of the cutscene, the `timeBetweenFrames` is the time between each frame in milliseconds and the `overAllTime` is the time of the cutscene in milliseconds.
In this marker, every frames will be 50 miliseconds or 1 minecraft tick, due to a minecraft limitation we can't go under 1 tick or 50 milliseconds.