package me.unurled.sacredrealms.cutscenes;

import java.util.ArrayList;
import java.util.List;
import org.bukkit.Location;

public class MarkerInterpolator {
    public static ArrayList<Frame> interpolateFrames(Marker startMarker, Marker endMarker, long stepMillis) {
        long duration = startMarker.getOverAllTime();

        int numFrames = (int) (duration / stepMillis);

        double xDiff = (endMarker.getStart().getX() - startMarker.getStart().getX()) / numFrames;
        double yDiff = (endMarker.getStart().getY() - startMarker.getStart().getY()) / numFrames;
        double zDiff = (endMarker.getStart().getZ() - startMarker.getStart().getZ()) / numFrames;
        double yawDiff = (endMarker.getStart().getYaw() - startMarker.getStart().getYaw()) / numFrames;
        double pitchDiff = (endMarker.getStart().getPitch() - startMarker.getStart().getPitch()) / numFrames;

        ArrayList<Frame> frames = new ArrayList<>();

        for (int i = 0; i < numFrames; i++) {

            double x = startMarker.getStart().getX() + xDiff * i;
            double y = startMarker.getStart().getY() + yDiff * i;
            double z = startMarker.getStart().getZ() + zDiff * i;
            double yaw = startMarker.getStart().getYaw() + yawDiff * i;
            double pitch = startMarker.getStart().getPitch() + pitchDiff * i;

            Frame frame = new Frame(
                new Location(startMarker.getStart().getWorld(), x, y, z, (float) yaw, (float) pitch)
            );

            frames.add(frame);
        }
        System.out.println(numFrames + " " +frames.size());
        return frames;
    }
}
